#ifndef _CL_AMS_MGMT_SERVER_FUNC_TABLE_H_
#define _CL_AMS_MGMT_SERVER_FUNC_TABLE_H_

#if !defined (__SERVER__) && !defined (__CLIENT__)
#error "This file should be included  from server or client. Define __SERVER__ or __CLIENT__ if you are server or client and then recompile"
#endif

#ifdef __cplusplus
extern "C" {
#endif

#define __AMS_FUNC_ID(id) AMS_FUNC_ID(CL_AMS_MGMT_SERVER_TABLE_ID, id)
#define __AMS_FUNC_ID2(id) AMS_FUNC_ID( CL_AMS_MGMT_SERVER_TABLE2_ID, (id) & CL_EO_FN_MASK)

CL_EO_CALLBACK_TABLE_DECL(amsMgmtServerFuncList)[] =
{
    VSYM_EMPTY(NULL, 0),
    VSYM(_clAmsMgmtInitialize, __AMS_FUNC_ID(CL_AMS_MGMT_INITIALIZE)),
    VSYM(_clAmsMgmtFinalize, __AMS_FUNC_ID(CL_AMS_MGMT_FINALIZE)),
    VSYM(_clAmsMgmtEntityCreate, __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_CREATE)),
    VSYM(_clAmsMgmtEntityDelete, __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_DELETE)),
    VSYM_VER(_clAmsMgmtEntitySetConfig, CL_RELEASE_VERSION_BASE, CL_MAJOR_VERSION_BASE, CL_MINOR_VERSION_BASE, 
             __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_SET_CONFIG)),
    VSYM_VER(_clAmsMgmtEntitySetConfig, CL_RELEASE_VERSION, 1, CL_MINOR_VERSION, 
             __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_SET_CONFIG)),
    VSYM_VER(_clAmsMgmtEntitySetConfig, 5, 0, 0,
             __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_SET_CONFIG)),
    VSYM(_clAmsMgmtEntityLockAssignment, __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_LOCK_ASSIGNMENT)),
    VSYM(_clAmsMgmtEntityLockInstantiation,  __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_LOCK_INSTANTIATION)),
    VSYM(_clAmsMgmtEntityUnlock, __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_UNLOCK)),  
    VSYM(_clAmsMgmtEntityShutdown, __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_SHUTDOWN)),
    VSYM(_clAmsMgmtEntityRestart, __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_RESTART)),
    VSYM(_clAmsMgmtEntityRepaired, __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_REPAIRED)),
    VSYM(_clAmsMgmtSGAdjustPreference, __AMS_FUNC_ID(CL_AMS_MGMT_SG_ADJUST_PREFERENCE)),
    VSYM(_clAmsMgmtSISwap, __AMS_FUNC_ID(CL_AMS_MGMT_SI_SWAP)),
    VSYM(_clAmsMgmtEntityListEntityRefAdd, __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_LIST_ENTITY_REF_ADD)),
    VSYM(_clAmsMgmtEntitySetRef, __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_SET_REF)),
    VSYM(_clAmsMgmtCSISetNVP, __AMS_FUNC_ID(CL_AMS_MGMT_CSI_SET_NVP)),
    VSYM(_clAmsMgmtDebugEnable, __AMS_FUNC_ID(CL_AMS_MGMT_DEBUG_ENABLE)),
    VSYM(_clAmsMgmtDebugDisable, __AMS_FUNC_ID(CL_AMS_MGMT_DEBUG_DISABLE)),
    VSYM(_clAmsMgmtDebugGet, __AMS_FUNC_ID(CL_AMS_MGMT_DEBUG_GET)),
    VSYM(_clAmsMgmtDebugEnableLogToConsole, __AMS_FUNC_ID(CL_AMS_MGMT_DEBUG_ENABLE_LOG_TO_CONSOLE)),
    VSYM(_clAmsMgmtDebugDisableLogToConsole, __AMS_FUNC_ID(CL_AMS_MGMT_DEBUG_DISABLE_LOG_TO_CONSOLE)),
    VSYM(_clAmsMgmtCCBInitialize, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_INITIALIZE)),
    VSYM(_clAmsMgmtCCBFinalize, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_FINALIZE)),
    VSYM_VER(_clAmsMgmtCCBEntitySetConfig, CL_RELEASE_VERSION_BASE, CL_MAJOR_VERSION_BASE, CL_MINOR_VERSION_BASE,
             __AMS_FUNC_ID(CL_AMS_MGMT_CCB_ENTITY_SET_CONFIG)),
    VSYM_VER(_clAmsMgmtCCBEntitySetConfig, CL_RELEASE_VERSION, 1, CL_MINOR_VERSION,
             __AMS_FUNC_ID(CL_AMS_MGMT_CCB_ENTITY_SET_CONFIG)),
    VSYM_VER(_clAmsMgmtCCBEntitySetConfig, 5, 0, 0,
             __AMS_FUNC_ID(CL_AMS_MGMT_CCB_ENTITY_SET_CONFIG)),
    VSYM(_clAmsMgmtCCBCSISetNVP, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_CSI_SET_NVP)),
    VSYM(_clAmsMgmtCCBSetNodeDependency, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_SET_NODE_DEPENDENCY)),
    VSYM(_clAmsMgmtCCBSetNodeSUList, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_SET_NODE_SU_LIST)),
    VSYM(_clAmsMgmtCCBSetSGSUList, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_SET_SG_SU_LIST)),
    VSYM(_clAmsMgmtCCBSetSGSIList, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_SET_SG_SI_LIST)),
    VSYM(_clAmsMgmtCCBSetSUCompList, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_SET_SU_COMP_LIST)),
    VSYM(_clAmsMgmtCCBSetSISURankList, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_SET_SI_SU_RANK_LIST)),
    VSYM(_clAmsMgmtCCBSetSISIDependency, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_SET_SI_SI_DEPENDENCY)),
    VSYM(_clAmsMgmtCCBSetSICSIList, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_SET_SI_CSI_LIST)),
    VSYM_EMPTY(NULL, 0),
    VSYM_EMPTY(NULL, 0),
    VSYM(_clAmsMgmtCCBEntityCreate, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_ENTITY_CREATE)),
    VSYM(_clAmsMgmtCCBEntityDelete, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_ENTITY_DELETE)),
    VSYM(_clAmsMgmtCCBCommit, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_COMMIT)),

    VSYM_VER(_clAmsMgmtEntityGet, CL_RELEASE_VERSION_BASE, CL_MAJOR_VERSION_BASE, CL_MINOR_VERSION_BASE,  
             __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_GET)),
    VSYM_VER(_clAmsMgmtEntityGet, CL_RELEASE_VERSION, 1, CL_MINOR_VERSION, 
             __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_GET)),
    VSYM_VER(_clAmsMgmtEntityGet, 5, 0, 0,
             __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_GET)),
    VSYM_VER(_clAmsMgmtEntityGet, 5, 1, 0,
             __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_GET)),

    VSYM_VER(_clAmsMgmtEntityGetConfig, CL_RELEASE_VERSION_BASE, CL_MAJOR_VERSION_BASE, CL_MINOR_VERSION_BASE,
             __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_GET_CONFIG)),
    VSYM_VER(_clAmsMgmtEntityGetConfig, CL_RELEASE_VERSION, 1, CL_MINOR_VERSION,
             __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_GET_CONFIG)),
    VSYM_VER(_clAmsMgmtEntityGetConfig, 5, 0, 0,
             __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_GET_CONFIG)),

    VSYM_VER(_clAmsMgmtEntityGetStatus, 
             CL_RELEASE_VERSION_BASE, CL_MAJOR_VERSION_BASE, CL_MINOR_VERSION_BASE, 
             __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_GET_STATUS)),
    VSYM_VER(_clAmsMgmtEntityGetStatus, CL_RELEASE_VERSION, 1, CL_MINOR_VERSION, 
             __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_GET_STATUS)),
    VSYM_VER(_clAmsMgmtEntityGetStatus, 5, 1, 0,
             __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_GET_STATUS)),

    VSYM(_clAmsMgmtGetCSINVPList, __AMS_FUNC_ID(CL_AMS_MGMT_GET_CSI_NVP_LIST)),
    VSYM(_clAmsMgmtGetEntityList, __AMS_FUNC_ID(CL_AMS_MGMT_GET_ENTITY_LIST)),
    VSYM(_clAmsMgmtGetOLEntityList, __AMS_FUNC_ID(CL_AMS_MGMT_GET_OL_ENTITY_LIST)),
    VSYM(_clAmsMgmtCCBCSIDeleteNVP, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_CSI_DELETE_NVP)),
    VSYM(_clAmsMgmtCCBDeleteNodeDependency, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_DELETE_NODE_DEPENDENCY)),
    VSYM(_clAmsMgmtCCBDeleteNodeSUList, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_DELETE_NODE_SU_LIST)),
    VSYM(_clAmsMgmtCCBDeleteSGSUList, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_DELETE_SG_SU_LIST)),
    VSYM(_clAmsMgmtCCBDeleteSGSIList, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_DELETE_SG_SI_LIST)),
    VSYM(_clAmsMgmtCCBDeleteSUCompList, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_DELETE_SU_COMP_LIST)),
    VSYM(_clAmsMgmtCCBDeleteSISURankList, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_DELETE_SI_SU_RANK_LIST)),
    VSYM(_clAmsMgmtCCBDeleteSISIDependency, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_DELETE_SI_SI_DEPENDENCY)),
    VSYM(_clAmsMgmtCCBDeleteSICSIList, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_DELETE_SI_CSI_LIST)),
    VSYM(_clAmsMgmtEntitySetAlphaFactor, __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_SET_ALPHA_FACTOR)),
    VSYM(_clAmsMgmtMigrateSG, __AMS_FUNC_ID(CL_AMS_MGMT_MIGRATE_SG)),
    VSYM(_clAmsMgmtEntityUserDataSet, __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_USER_DATA_SET)),
    VSYM(_clAmsMgmtEntityUserDataSetKey, __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_USER_DATA_SETKEY)),
    VSYM(_clAmsMgmtEntityUserDataGet, __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_USER_DATA_GET)),
    VSYM(_clAmsMgmtEntityUserDataGetKey, __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_USER_DATA_GETKEY)),
    VSYM(_clAmsMgmtEntityUserDataDelete, __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_USER_DATA_DELETE)),
    VSYM(_clAmsMgmtEntityUserDataDeleteKey, __AMS_FUNC_ID(CL_AMS_MGMT_ENTITY_USER_DATA_DELETEKEY)),
    VSYM(_clAmsMgmtCCBSetCSICSIDependency, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_SET_CSI_CSI_DEPENDENCY)),
    VSYM(_clAmsMgmtCCBDeleteCSICSIDependency, __AMS_FUNC_ID(CL_AMS_MGMT_CCB_DELETE_CSI_CSI_DEPENDENCY)),
    VSYM_NULL,
};

CL_EO_CALLBACK_TABLE_DECL(amsMgmtServerFuncList2)[]=
{
    VSYM_EMPTY(NULL, 0),
    VSYM(_clAmsMgmtSIAssignSUCustom, __AMS_FUNC_ID2(CL_AMS_MGMT_SI_ASSIGN_SU_CUSTOM)),
    VSYM(_clAmsMgmtEntitySetBetaFactor, __AMS_FUNC_ID2(CL_AMS_MGMT_ENTITY_SET_BETA_FACTOR)),
    VSYM(_clAmsMgmtEntityForceLock, __AMS_FUNC_ID2(CL_AMS_MGMT_ENTITY_FORCE_LOCK)),
    VSYM_VER(_clAmsMgmtDBGet, 5, 1, 0, __AMS_FUNC_ID2(CL_AMS_MGMT_DB_GET)),
    VSYM_VER(_clAmsMgmtComputedAdminStateGet, 5, 0, 0, __AMS_FUNC_ID2(CL_AMS_MGMT_COMPUTED_ADMIN_STATE_GET)),
    VSYM_VER(_clAmsMgmtEntityForceLockInstantiation, 5, 0, 0, __AMS_FUNC_ID2(CL_AMS_MGMT_ENTITY_FORCE_LOCK_INSTANTIATION)),
    VSYM_VER(_clAmsMgmtCCBBatchCommit, 5, 1, 0, 
             __AMS_FUNC_ID2(CL_AMS_MGMT_CCB_BATCH_COMMIT)),
    VSYM_VER(_clAmsMgmtEntityShutdownWithRestart, 5, 1, 0, 
             __AMS_FUNC_ID2(CL_AMS_MGMT_ENTITY_SHUTDOWN_WITH_RESTART)),
    VSYM_NULL,
};

CL_EO_CALLBACK_TABLE_LIST_DECL(gAspFuncTable, AMFMgmtServer)[] =
{
    CL_EO_CALLBACK_TABLE_LIST_DEF(CL_AMS_MGMT_SERVER_TABLE_ID, amsMgmtServerFuncList),
    CL_EO_CALLBACK_TABLE_LIST_DEF(CL_AMS_MGMT_SERVER_TABLE2_ID, amsMgmtServerFuncList2),
    CL_EO_CALLBACK_TABLE_LIST_DEF_NULL,
};

#ifdef __cplusplus
}
#endif

#endif
